<?php

use yii;

use app\models\connection\Dellin;

use DateTime;

?>

<link href="/css/pages/cart.css" rel="stylesheet">

<div id="page_cart" class="container mb-auto py-3">
    <article class="py-3 px-4 rounded">
        <h4 class="ml-4 mt-2 mb-4"><i class="fas fa-shopping-cart mr-2"></i>Корзина</h4>
        <div class="col mb-4 list rounded overflow-hidden">
            <div class="row py-2">
                <div class="pl-3 mr-1">
                    <input id="checkbox_cart_all" type="checkbox" onchange="return cart_list_checkbox(this);" />
                </div>
                <div class="col-2">
                    <span>Артикул</span>
                </div>
                <div class="col-4">
                    <span>Описание</span>
                </div>
                <div class="col-1 ml-auto  px-0 text-center">
                    <span>Количество</span>
                </div>
                <div class="col-2 text-right">
                    <span>Доставка</span>
                </div>
                <div class="col-2 mr-3 text-right">
                    <span>Стоимость</span>
                </div>
            </div>
            <?php
            if (isset($connections) && !empty($connections)) {
                foreach ($connections as $connection) {
                    // Перебор поставок

                    // Инициализация доставки
                    if (isset($connection['delivery']['error'])) {
                        // Не удалось рассчитать доставку

                        // Инициализация времени
                        $delivery = '?';

                        // Инициализация цены
                        $cost = '?';
                    } else {
                        // Удалось рассчитать доставку

                        // Инициализация времени
                        try {
                            $delivery_converted = DateTime::createFromFormat('Y-m-d H:i:s', $connection['delivery']['orderDates']['giveoutFromOspReceiver'])->getTimestamp();
                        } catch(Exception $e) {
                            $delivery_converted = DateTime::createFromFormat('Y-m-d', $connection['delivery']['orderDates']['arrivalToOspReceiver'])->getTimestamp();
                        }
                        $delivery = ceil(($delivery_converted - time()) / 60 / 60 / 24) + 1;

                        // Инициализация цены
                        $cost = $connection['cost'] . ' ' . $connection['currency'];
                    }

                    // Инициализация комментария
                    $comment = $connection['order_edge_supply'][0]['comm'] ?? 'Комментарий к заказу';

                    echo <<<HTML
                        <div class="row py-2 cart_list_target">
                            <div class="col">
                                <div class="row">
                                    <div class="pl-3 my-auto mr-1">
                                        <input id="cart_list_checkbox_{$connection['supply']['catn']}" type="checkbox" onchange="return cart_list_checkbox(this);"/>
                                    </div>
                                    <div class="col-2 my-auto">
                                        {$connection['supply']['catn']}
                                    </div>
                                    <div class="col-4 my-auto">
                                        {$connection['supply']['dscr']}
                                    </div>
                                    <div class="col-1 my-auto ml-auto">
                                        <input id="cart_list_amnt_{$connection['supply']['catn']}" class="form-control text-center" type="text" value="{$connection['amount']}" onchange="return cart_list_amount_update('{$connection['supply']['catn']}', this)" aria-invalid="false">
                                    </div>
                                    <div class="col-2 my-auto text-right">
                                        <a type="button" onclick="return false;">$delivery дн</a>
                                    </div>
                                    <div class="col-2 my-auto mr-3 text-right">
                                        $cost
                                    </div>
                                </div>
                                <div class="dropdown-divider"></div>
                                <div class="row mb-1">
                                    <div class="col-12">
                                        <p id="cart_list_comment_{$connection['supply']['catn']}" class="mt-0 ml-0 text-break pointer-event" role="button" onclick="return cart_list_comment_edit('{$connection['supply']['catn']}', this);">$comment</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                    HTML;
                }
            } else {
                echo <<<HTML
                    <div class="row py-2 cart_list_target">
                        <div class="mx-auto py-2">
                            Корзина пуста
                        </div>
                    </div>
                HTML;
            }
            ?>
        </div>
        <div class="row mb-2 mx-0">
            <select id="cart_list_action" class="form-control mr-3 button_clean w-auto" name="CartListAction">
                <option value="none" hidden>Действие с выбранными</option>
                <option value="delete" onclick="return cart_list_delete();">Удалить</option>
            </select>
            <a class="mr-3 btn button_red button_clean" title="Очистить корзину" href="/cart" role="button" onclick="return cart_delete();">
                Очистить
            </a>
            <p class="ml-auto mr-3 cart_field_cost">
                <span id="cart_cost">0</span>
                руб
            </p>
            <a class="btn button_clean button_blue" title="Оформить заказ" href="/pay" role="button" onclick="return cart_pay();">
                Оформить заказ
            </a>
        </div>
    </article>
</div>

<script src="/js/textarea.js" defer></script>
<script src="/js/cart.js" defer></script>
